import kivy
kivy.require('1.0.8')

from kivy.core.window import Window
from kivy.uix.widget import Widget
from kivy.graphics import Fbo, Color, Rectangle

class Character():
    #Red,Green,Blue,Alpha Opacity
    color=Color(1,1,1,1)
    rectangle=Rectangle(pos=(100,100),size=(64,64) )

    def setX(self,x):
        self.rectangle.pos=(x,self.rectangle.pos[1])

    def setY(self,y):
        self.rectangle.pos=(self.rectangle.pos[0],y)

    def getX(self):
        return self.rectangle.pos[0]

    def getY(self):
        return self.rectangle.pos[1]


class CanvasForm(Widget):
    player1=Character()

    def __init__(self, **kwargs):
        super(CanvasForm, self).__init__(**kwargs)
        self._keyboard = Window.request_keyboard(
            self._keyboard_closed, self)
        self._keyboard.bind(on_key_down=self._on_keyboard_down)

        #with self.canvas:
        #    Color(0, 1, 0, .8)
        #    Rectangle(pos=self.player1.pos, size=self.player1.size)
        #self.canvas.add(Color(1., 1., 0))
        #self.canvas.add(Rectangle(size=(50, 50)))
        self.canvas.add(self.player1.color)
        self.canvas.add(self.player1.rectangle)

    def _keyboard_closed(self):
        print 'Keyboard disconnectd!'
        self._keyboard.unbind(on_key_down=self._on_keyboard_down)
        self._keyboard = None

    def _on_keyboard_down(self, keyboard, keycode, text, modifiers):
        print 'The key', keycode, ' pressed'
        print ' - text is %r' % text
        print ' - modifiers are %r' % modifiers

        # Keycode is composed of an integer + a string
        # If we hit escape, release the keyboard
        if keycode[1] == 'escape':
            keyboard.release()
        elif keycode[1] == 'left':
            self.player1.setX(self.player1.getX()-10)
        elif keycode[1] == 'right':
            self.player1.setX(self.player1.getX()+10)

        #with self.canvas:
        #    Color(0, 1, 0, .8)
        #    Rectangle(pos=self.player1.pos, size=self.player1.size)

        # Return True to accept the key. Otherwise, it will be used by
        # the system.
        return True


if __name__ == '__main__':
    from kivy.base import runTouchApp
    runTouchApp(CanvasForm())
